<?php
/*****************************************************************************
 * ID   : $Id: pager.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
class pager {
	
	//ページ名	
	var $myRequestPageName = "";
	var $myIsArg = false;
	
	//現在のページ数
	var $myRequestPageNum = 1;

	//次のページリンク
	var $myFrontPageLink = "";
	//前のページリンク
	var $myBackPageLink  = "";
	//最初のページリンク	
	var $myFirstPageLink = "";
	//最後のページリンク	
	var $myLastPageLink  = "";

	//ページリスト
	var $myPageList = array();
	
	//ページ指示指定子
	var $myPageID        = "page";
	//次のページ指定子
	var $myFrontPageChar = "&gt;";
	//最後のページ指定子
	var $myLastPageChar  = "&gt;&gt;";
	//前のページ指定子
	var $myBackPageChar  = "&lt;";
	//最初のページ指定子
	var $myFirstPageChar = "&lt;&lt;";
	//空ページ指定子
	var $myEmptyPageChar = " ";

	/**
	 * コンストラクタ
	 */
	function pager($aRequestPageName,$aIsArg = false)
	{
        // クラスのコンストラクタ。これらは新しいインスタンスで自動的にセットされます。
        $this->myRequestPageName = $aRequestPageName;
       	//前ページをリテラルで設定しておく 
    	$this->myBackPageLink = $this->myBackPageChar;
       	//次ページをリテラルで設定しておく 
    	$this->myFrontPageLink = $this->myFrontPageChar;
    	//最初のページをリテラルで設定しておく
    	$this->myFirstPageLink = $this->myFirstPageChar;
    	//最後のページをリテラルで設定しておく
    	$this->myLastPageLink = $this->myLastPageChar;
    	
    	//引数が存在するかを設定
    	$this->myIsArg = $aIsArg;
	}

	/**
	 * オブジェクトを作成する
	 */	
	function analytics($aNowPage,$aMaxPage,$aListNum) {
		
		//現在のページをリクエストページとして設定	
		$this->setRequestPageNum($aNowPage);
	
		$wkIdx = $aNowPage - ($aListNum/2);
		//リスト開始番号
		$startPage = $wkIdx;
		if ( $startPage <= 0 ) {
			$startPage = 1;
		}
		$startPage = (int)$startPage;
		//最終ページを開始ページから＋表示数する	
		$endPage = $startPage + $aListNum - 1;
		//ページ数が表示数に満たない場合
		if ( ($endPage > $aMaxPage) && $wkIdx > 0 ) {
			$endPage   = $aMaxPage;
			$startPage = $endPage - $aListNum + 1;
		}

		//ページIDのリストを生成
		for ( $cnt = $startPage; $cnt <= $endPage ; ++$cnt) {
			//すでに上限ページを越した場合
			if ( $cnt > $aMaxPage ) {
				$this->addEmptyPage();
			} else {
				$this->addPage($cnt);
			}
		}

		//現在ページが１ページ目でない場合
		if ( $aNowPage != 1 ) {
			//最初のページを１に設定
			$this->setFirstPageLink(1);
		}
		//最終ページが現在のページでない場合	
		if ( $aMaxPage != $aNowPage ) {
			//最終ページを設定
			$this->setLastPageLink($aMaxPage);
		}
	}

	/**
	 * ページリンクを追加
	 * 現在のページ±１ページをリクエストした場合
	 * 次と前のページリンク等を更新する
	 */
	function addPage($aPageNum) {

		//ページ配列数を取得
		$cnt = count($this->myPageList);
		$pageLink = $aPageNum;
		//現在のページじゃない場合
		if ( $this->myRequestPageNum != $aPageNum ) {
			//ページリンクを設定
			$pageLink = $this->createPageLink($aPageNum,$aPageNum);
			//取得するページが前のページだった場合	
			if ( $aPageNum == ($this->myRequestPageNum + 1) ) {
				$wkLink = $this->createPageLink($aPageNum,$this->myFrontPageChar);
				$this->myFrontPageLink = $wkLink;
			} else if ( $aPageNum == ($this->myRequestPageNum - 1 )  ) {
				$wkLink = $this->createPageLink($aPageNum,$this->myBackPageChar);
				$this->myBackPageLink  = $wkLink;
			}
		}
		//ページリンクをメンバ配列に設定
		$this->myPageList[$cnt] = $pageLink;
	}

	/**
	 * 表示なしページとしてページを追加
	 */	
	function addEmptyPage() {
		//ページ配列数を取得
		$cnt = count($this->myPageList);
		//空ページ用の文字列をメンバ配列に設定
		$this->myPageList[$cnt] = $this->myEmptyPageChar;
	}

	/**
	 * ページリンクを設定
	 */	
	function createPageLink($aPageNum,$aPageMark) {
	
		$page = "";	
		$arg = "?";
		if ( $this->myIsArg ) {
			$arg = "&";
		}
		//ページ名を作成	
		$page = $this->myRequestPageName . '?' . $this->myPageID . '=' . $aPageNum;
		$rtn = '<a href="' . $page . '">' . $aPageMark . '</a>';
		return $rtn;
	}

	/**
	 * ページリスト取得
	 */	
	function getPageList() {
		return $this->myPageList;
	}
	
	//現在のページ数
	function getRequestPageNum() {
		return $this->myRequestPageNum;
	}

	//次のページリンク
	function getFrontPageLink() {
		return $this->myFrontPageLink;
	}
	
	//前のページリンク
	function getBackPageLink() {
		return $this->myBackPageLink;
	}
		
	//最初のページリンク	
	function getFirstPageLink() {
		return $this->myFirstPageLink;
		
	}
	//最後のページリンク	
	function getLastPageLink() {
		return $this->myLastPageLink;
	}

	function setPageID($aID) {
		$this->myPageID = $aID;
	}

	//現在のページ数
	function setRequestPageNum($aRequestPageNum) {
		$this->myRequestPageNum = $aRequestPageNum;
	}

	//次のページリンク
	function setFrontPageLink ($aPageNum) {
		$pageLink = $this->createPageLink($aPageNum,$this->myFrontPageChar);
		$this->myFrontPageLink = $pageLink;
	}
	
	//前のページリンク
	function setBackPageLink($aPageNum) {
		$pageLink = $this->createPageLink($aPageNum,$this->myBackPageChar);
		$this->myBackPageLink = $pageLink;
	}
	
	//最初のページリンク	
	function setFirstPageLink($aPageNum) {
		$pageLink = $this->createPageLink($aPageNum,$this->myFirstPageChar);
		$this->myFirstPageLink = $pageLink;
	}

	//最後のページリンク	
	function setLastPageLink($aPageNum) {
		$pageLink = $this->createPageLink($aPageNum,$this->myLastPageLink);
		$this->myLastPageLink = $pageLink;
	}
} 

?>