<?php
/*****************************************************************************
 * ID   : $Id: schema_tb.php,v 1.2 2007/08/18 08:12:38 secondarykey Exp $
 * Name : ページ属性スキーマ定義テーブル操作
 * Specifications : ページ属性のスキーマを定義、操作する為のクラスです。
 ****************************************************************************/
  class schema_tb extends tables { 

  	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "schema_tb"; 
	var $myColumnName       = "id,template_page_id,name,variable,type,must,arg";
	var $myInsertColumnName = "template_page_id,name,variable,type,must,arg";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "id";

	/**
	 * メンバ変数
	 **/	
 	var $myID;	
	var $myTemplate_Page_ID;	
	var $myName;	
	var $myVariable;	
	var $myType;	
	var $myMust;	
	var $myArg;	

	//変数種別名	
	var $myTypeArray = array(
                       'プレーンテキスト',
                       'ＨＴＭＬテキスト',
                       'リンクテキスト',
                       'リンクテキスト(HTML)',
                       '画像(アップロード)',
                       '画像マスタ指定',
                       'マスタ指定'
                       );
   	//必須名
	var $myMustArray = array(
                       'なし',
                       '必須'
                       );
  
	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return       $this->myTemplate_Page_ID . "," . 
		        "'" . $this->myName             . "'," . 
		        "'" . $this->myVariable         . "'," . 
		              $this->myType             . "," . 
		              $this->myMust             . "," .
		              $this->myArg;
	}	
	
	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " template_page_id = " . $this->myTemplate_Page_ID . "," .
                " name = '"            . $this->myName             . "'," .
                " variable = '"        . $this->myVariable         . "'," .
                " type = "             . $this->myType             . "," .
                " must = "             . $this->myMust             . "," .
                " arg = "              . $this->myArg;
	}	

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	schema_tb();
		$obj->setID($aRow->id);
		$obj->setTemplate_Page_ID($aRow->template_page_id);
		$obj->setName($aRow->name);
		$obj->setVariable($aRow->variable);
		$obj->setVariableType($aRow->type);
		$obj->setMust($aRow->must);
		$obj->setArg($aRow->arg);
		return $obj;
	}
	
	//指定したページテンプレートIDで取得
 	function selectTemplatePageID($aTemplatePageID) {
		//コネクションを取得	
		$con = DatabaseAccess::getConnection();
		//SQLを設定
		$sql = "select *  from schema_tb" . 
               " where template_page_id = " . $aTemplatePageID;
		//SQLを実行
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return null;
		}
		//カウントを取得
  		$count = mysql_num_rows($query);
  		//０件だった場合
		if($count == 0 ){
			return null;
		}
		$idx = 0;
		$rtn = array();

		//オブジェクト数回繰り返す
		while ( $row = mysql_fetch_object($query) ) {
			$obj = schema_tb::createObject($row);
			$rtn[$idx] = $obj;
			++$idx;
		}
		//結果は使用側が行うこと
		mysql_free_result($query);
		return $rtn;	
 	}	

	/**
	 * テンプレートの属性定義テーブルを作成
	 */
 	function createAttributeTable($aTables) {
 		$rtnTable = "<table border=\"1\" width=\"100%\">";

		$rtnTable = $rtnTable . "<tr>";
		$rtnTable = $rtnTable . "<td></td>";
		$rtnTable = $rtnTable . "<td>名称</td>";
		$rtnTable = $rtnTable . "<td>変数名</td>";
		$rtnTable = $rtnTable . "<td>タイプ</td>";
		$rtnTable = $rtnTable . "<td>必須</td>";
		$rtnTable = $rtnTable . "<td>マスタＩＤ(マスタ指定時)</td>";
		$rtnTable = $rtnTable . "</tr>";

 		$num = 1;
 		//存在しない場合	
 		if ( $aTables == null ) {
 			$master_tb = new master_tb;
 			$selection = $master_tb->getSelection("","%s");
 			//１００個作成する
 			for ( $cnt = 1; $cnt <= 100; ++$cnt ) {

				$type = $this->getTypeSelection("","type" . $cnt);
				$must = $this->getMustSelection("must" . $cnt);

				$arg = sprintf($selection,"arg".$cnt);

 				$rtnTable = $rtnTable . "<tr>";
 				$rtnTable = $rtnTable . "<td>" . $cnt . "</td>";
 				$rtnTable = $rtnTable . "<td><input type=\"text\" name=\"name". $cnt ."\"></td>";
 				$rtnTable = $rtnTable . "<td><input type=\"text\" name=\"variable". $cnt ."\"></td>";
 				$rtnTable = $rtnTable . "<td>" . $type . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $must . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $arg . "</td>";
 				$rtnTable = $rtnTable . "</tr>";
 			}
 		} else {
 			//テンプレート数回繰り返す	
			foreach ($aTables as $elm) {
				$typeValue = $elm->getVariableType();
				//変数タイプを取得
 				$typeName = $this->myTypeArray[$typeValue];
 				//必須を取得
 				$must = $elm->getMust();
 				$mustName = $this->myMustArray[$must];
 
 				//引数を取得
 				$argName = "";
 				//マスタだった場合
 				if ( $typeValue == 6 ) {
 					$arg = $elm->getArg();
 					$master_tb = new master_tb();	
 					$obj = $master_tb->selectByID($arg);
 					$argName = $obj[0]->getName();
 				}
 				
 				$rtnTable = $rtnTable . "<tr>";
 				$rtnTable = $rtnTable . "<td>" . $num . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $elm->getName() . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $elm->getVariable() . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $typeName . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $mustName . "</td>";
 				$rtnTable = $rtnTable . "<td>" . $argName . "</td>";
 				$rtnTable = $rtnTable . "</tr>";
 				$num = $num + 1;
			}
 		}
 		$rtnTable = $rtnTable . "</table>";
 		return $rtnTable;
 	}

 	/**	
 	 * ページ属性を作成
 	 */
 	function createPageAttributeTable($aPage,$aSchema) {
 
 		$log="";
 		//ページID
 		$id     = $aPage->getID();
 		$tempid = $aPage->getTemplate_Page_ID();
 		//テーブル名称
 		$tableName = page_attribute_tb::getTableName($tempid);
 
 		$rtnTable = "<table border=\"1\" width=\"100%\">";
 		//データを検索	
 		$sql = "select * from " . $tableName .
 		       " where pageid = " . $id;
		$con = DatabaseAccess::getConnection();
		//SQLを実行
		$query = mysql_query($sql,$con);


		$row = null;
		if ( $query != null ) {
			//列を取得	
			$row = mysql_fetch_array($query);
		}
		
 		$rtnTable = $rtnTable . "<tr>";
 		$rtnTable = $rtnTable . "<td>名称</td>";
 		$rtnTable = $rtnTable . "<td>設定値</td>";
 		$rtnTable = $rtnTable . "</tr>";
 
 		$rtnTable = $rtnTable . '<input type="hidden" name="id" value="' . $id . '">';

 		//スキーマが存在した場合
 		if ( $aSchema != null ) {
 			//検索データを取得
			foreach ( $aSchema as $elm ) {

	 			$rtnTable = $rtnTable . "<tr>";
	 			//名称を取得	
	 			$name = $elm->getName();
	 			//変数名を取得
	 			$vari = $elm->getVariable();
	 			//変数タイプを取得
	 			$type = $elm->getVariableType();
	 			$must = $elm->getMust();
	 			//マスタ値を取得
	 			$arg  = $elm->getArg();
				//名称を設定
	 			$rtnTable = $rtnTable . "<td>" . $name . "</td>";
	 			$rtnTable = $rtnTable . "<td>";
	
	 			if ( $type == 5 ) {
	 				$value = "";
	 				//マスタ画像指定
	 				if ( $row != null ) {
	 					//画像を表示
	 					$value = $row[$vari];
	 				}
	 				//ID入力を設定
	 				$rtnTable = $rtnTable . '<input type="text" name="' . $vari . '" value="' . $value . '">';
	 			} else if ( $type == 6 ) {
	 				//マスタ指定
	 				$masterData = "";
	 				if ( $row != null ) {
	 					//マスタの値を取得
	 					$masterData = $row[$vari];
	 				}
		 			
	 				//マスタを指定して一覧を作成
	 				$masterdata_tb = new masterdata_tb;
	 				//IDを指定して検索
	 				$selection = $masterdata_tb->getSelection($masterData,$arg,$vari);
	 				$rtnTable = $rtnTable . $selection;
	
	 			} else if ( $type == 4 ) {
		 		
	 				$page_url = "page_attribute_image.php?id=" . $id . "&variable=" . $vari;	
					$rtnTable = $rtnTable . '<input type="button" name="exec" value="画像設定" onclick="return openAttributeImageWindow(\'' . $page_url . '\');">';
	 				//ファイル入力を指定
	 				//$rtnTable = $rtnTable . '<input type="file" name="' . $vari . '">';
	 			} else {
		 			//テキストタイプの場合
	 				$rtnTable = $rtnTable . '<textarea rows="4" style="width:100%;" name="' . $vari . '">';
	 				if ( $row != null ) {
	 					//データを取得
	 					$rtnTable = $rtnTable . $row[$vari];
	 				}
	 				$rtnTable = $rtnTable . '</textarea>';
	 			}
	 			$rtnTable = $rtnTable . "</td>";
	 			$rtnTable = $rtnTable . "</tr>";
			}
 		} else {
 			$rtnTable = $rtnTable . "<tr>";
 			$rtnTable = $rtnTable . '<td colspan="2">テンプレートの属性定義がされていません。</td>';
 			$rtnTable = $rtnTable . "</tr>";
 		
 		}
		
		if ( $query != null ) {
			//結果は使用側が行うこと
			mysql_free_result($query);
		}
 		$rtnTable = $rtnTable . "</table>";
 		$rtnTable = $rtnTable . $log;
		return $rtnTable;
 	}

 	function getTypeSelection($aID,$aName) {
		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';
		$num = 0;
		//テンプレート数回繰り返す	
		foreach ($this->myTypeArray as $elm) {
			$selected = "";
			//同一IDだった場合
			if ($num == $aID ) {
				//選択対象にする
				$selected = " selected";
			}
			//データを作成
			$opt_val = '<option value="' . $num . '"' . $selected . '>' . $elm . '</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
			//インデックスを加算
			$num = $num + 1;
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn; 
 	}
 	
 	function getMustSelection($aName) {
 		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';

		$num = 0;
		foreach ( $this->myMustArray as $elm ) {
			//テンプレート数回繰り返す
			$rtn = $rtn . '<option value="' . $num . '">' . $elm . '</option>';
			++$num;
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn;
 	}
 	
   	/**
	 * ページテンプレートスキーマ削除
	 */
	function delete($aTemplateID) {

		$con = DatabaseAccess::getConnection();
		$sql = "delete from " . $this->myTableName .
		       " where template_page_id = " . $aTemplateID;
		$query = mysql_query($sql,$con);
		if ( $query == FALSE ) {
			return false;
		}
		return true;
	}
 
  	function getID() {
		return $this->myID;
	}

	function getTemplate_Page_ID() {
		return $this->myTemplate_Page_ID;
	}
	
	function getName() {
		return $this->myName;
	}
	
	function getVariable() {
		return $this->myVariable;
	}
	
	function getVariableType() {
		return $this->myType;
	}
	
	function getMust() {
		return $this->myMust;
	}
	
	function getArg() {
		return $this->myArg;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}
	
	function setTemplate_Page_ID($aTemplate_Page_ID) {
		$this->myTemplate_Page_ID = $aTemplate_Page_ID;
	}
	
	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setVariable($aVariable) {
		$this->myVariable = $aVariable;
	}
	
	function setVariableType($aVariableType) {
		$this->myType = $aVariableType;
	}
	
	function setMust($aMust) {
		$this->myMust = $aMust;
	}
	
	function setArg($aArg) {
		$this->myArg = $aArg;
	}
  } 
?>
