<?php
/*****************************************************************************
 * ID   : $Id: template_page_tb.php,v 1.1 2007/03/16 14:05:52 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
  class template_page_tb extends tables {

  	/**
	 * 基底クラス使用変数
	 */
	var $myTableName        = "template_page_tb"; 
	var $myColumnName       = "id,name,detail,pageListNum,pageListPageNum,childrenListNum,childrenListPageNum,childrenTemplateSiteID,childrenTemplatePageID";
	var $myInsertColumnName = "name,detail,pageListNum,pageListPageNum,childrenListNum,childrenListPageNum,childrenTemplateSiteID,childrenTemplatePageID";
	var $myOrgWhere         = "id";
	var $myOrderBy          = "id";

	/**
	 * メンバ変数
	 **/	
 	var $myID;	
	var $myName;	
	var $myDetail;	
	var $myPageListNum;
	var $myPageListPageNum;
	var $myChildrenListNum;
	var $myChildrenListPageNum;
	var $myChildrenTemplateSiteID;
	var $myChildrenTemplatePageID;

	/**
	 * 表挿入用のデータ
	 */
	function getInsertValue() {
		return "'" . $this->myName                   . "'," . 
		        "'" . $this->myDetail                 . "'," .
		              $this->myPageListNum            . ","  .
		              $this->myPageListPageNum        . ","  .
		              $this->myChildrenListNum        . ","  .
		              $this->myChildrenListPageNum    . ","  .
		              $this->myChildrenTemplateSiteID . ","  .
		              $this->myChildrenTemplatePageID;
	}	

	/**
	 * 更新用のデータ
	 */
	function getUpdateValue() {
		return " name = '"                  . $this->myName     . "'," . 
                " detail = '"                . $this->myDetail   . "'," .
                " pageListNum = "            . $this->myPageListNum            . ","  .
		        " pageListPageNum = "        . $this->myPageListPageNum        . ","  .
		        " childrenListNum = "        . $this->myChildrenListNum        . ","  .
		        " childrenListPageNum = "    . $this->myChildrenListPageNum    . ","  .
		        " childrenTemplateSiteID = " . $this->myChildrenTemplateSiteID . ","  .
		        " childrenTemplatePageID = " . $this->myChildrenTemplatePageID;
	}	

	/**
	 * オブジェクト生成
	 */
	function createObject($aRow) {
		$obj = new 	template_page_tb();
		$obj->setID($aRow->id);
		$obj->setName($aRow->name);
		$obj->setDetail($aRow->detail);
		$obj->setPageListNum($aRow->pageListNum);
		$obj->setPageListPageNum($aRow->pageListPageNum);
		$obj->setChildrenListNum($aRow->childrenListNum);
		$obj->setChildrenListPageNum($aRow->childrenListPageNum);
		$obj->setChildrenTemplateSiteID($aRow->childrenTemplateSiteID);
		$obj->setChildrenTemplatePageID($aRow->childrenTemplatePageID);
		return $obj;
	}	

	
	function getTemplateDirectory() {
		return SiteObject::get("TEMPLATE_PAGE_PATH");
	}
	
	function getTemplateFileName($aID) {
		return template_page_tb::getTemplateDirectory() . $aID . ".tpl";	
	}
	
	function createTemplateFile($aID) {
		$fileName = template_page_tb::getTemplateFileName($aID);	
		touch($fileName);
		chmod($fileName,0666);
		return;
	}

	function getTemplateData($aID) {
		//ファイル名を取得
		$fileName = template_page_tb::getTemplateFileName($aID);	
		$fh=fopen($fileName,"r");
		$data = fgets($fh);
		fclose($fh);
		return $data;
	}
	
	function updateTemplateData($aID,$aData) {
		//ファイル名を取得
		$fileName = template_page_tb::getTemplateFileName($aID);	
		$fh=fopen($fileName,"w");
		if ( $aData != "" ) {
			$value = str_replace("\x0D\x0A", "\x0D", $aData); 
			$wkvalue = str_replace("\\", "", $value); 
			//$writevalue = str_replace("\\\'", "\'", $wkvalue); 
			fputs($fh,$wkvalue);
		}
		fclose($fh);
		return;
	}
	
	function deleteTemplateData($aID) {
		//ファイル名を取得
		$fileName = template_page_tb::getTemplateFileName($aID);	
		$fh=unlink($fileName);
		return;
	}

	/**
	 * テンプレートの一覧を作成
	 */
	function getSelection($aID,$aName='template_page_id',$aEmpty=false) {

		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';
		//空白指定がある場合	
		if ( $aEmpty ) {
			$opt_val = '<option value="null">指定しない</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
		}
		$template_page_tb = new template_page_tb;
		//テンプレートを全件取得
		$tmp_array = $template_page_tb->select();

		//テンプレート数回繰り返す	
		foreach ($tmp_array as $elm) {
			$id   = $elm->getID();	
			$name = $elm->getName();	
			$selected = "";
			//同一IDだった場合
			if ($id == $aID ) {
				//選択対象にする
				$selected = " selected";
			}
			//データを作成
			$opt_val = '<option value="' . $id . '"' . $selected . '>' . $name . '</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn;
	}

	/**
	 * 数値のセレクションボックスを作成
	 */	
	function getNumberSelection($aNum,$aMax,$aName,$aEmpty=false) {
		//戻り値に名称を設定
		$rtn = '<select name="' . $aName . '">';
		//空白指定がある場合	
		if ( $aEmpty ) {
			$opt_val = '<option value="null">指定しない</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
		}
		//テンプレート数回繰り返す	
		for ($cnt=1; $cnt <= $aMax; ++$cnt ) {
			$selected = "";
			//同一IDだった場合
			if ($cnt == $aNum ) {
				//選択対象にする
				$selected = " selected";
			}
			//データを作成
			$opt_val = '<option value="' . $cnt . '"' . $selected . '>' . $cnt . '</option>';
			//一覧に追加
			$rtn = $rtn . $opt_val;
		}
		//タグを閉じる
		$rtn = $rtn . '</select>';
		return $rtn;
	}
	
  	function getID() {
		return $this->myID;
	}

	function getName() {
		return $this->myName;
	}
	
	function getDetail() {
		return $this->myDetail;
	}
	
	function getPageListNum() {
		return $this->myPageListNum;
	}
	
	function getPageListPageNum() {
		return $this->myPageListPageNum;
	}
	
	function getChildrenListNum() {
		return $this->myChildrenListNum;
	}
	
	function getChildrenListPageNum() {
		return $this->myChildrenListPageNum;
	}
	
	function getChildrenTemplateSiteID() {
		return $this->myChildrenTemplateSiteID;
	}
	
	function getChildrenTemplatePageID() {
		return $this->myChildrenTemplatePageID;
	}
	
	function setID($aID) {
		$this->myID = $aID;
	}
	
	function setName($aName) {
		$this->myName = $aName;
	}
	
	function setDetail($aDetail) {
		$this->myDetail = $aDetail;
	}
	
	function setPageListNum($aPageListNum) {
		$this->myPageListNum = $aPageListNum;
	}
	
	function setPageListPageNum($aPageListPageNum) {
		$this->myPageListPageNum = $aPageListPageNum;
	}
	
	function setChildrenListNum($aChildrenListNum) {
		$this->myChildrenListNum = $aChildrenListNum;
	}
	
	function setChildrenListPageNum($aChildrenListPageNum) {
		$this->myChildrenListPageNum = $aChildrenListPageNum;
	}
	
	function setChildrenTemplateSiteID($aChildrenTemplateSiteID) {
		$this->myChildrenTemplateSiteID = $aChildrenTemplateSiteID;
	}
	
	function setChildrenTemplatePageID($aChildrenTemplatePageID) {
		$this->myChildrenTemplatePageID = $aChildrenTemplatePageID;
	}
} 
?>
